#include "ScaFES.hpp"
#include "PropagationFromLeftLowerCorner.hpp"

const int DIM = 3;

int main(int argc, char *argv[]) {
    ScaFES::Parameters paramsCl(argc, argv);
    ScaFES::GridGlobal<DIM> gg(paramsCl);
    std::vector<std::string> nameDatafield(1); nameDatafield[0] = "U";
    std::vector<int> stencilWidth(1); stencilWidth[0] = 1;
    std::vector<bool> isKnownDf(1); isKnownDf[0] = false;
    std::vector<int> nLayers(1); nLayers[0] = 0;
    std::vector<double> defaultValue(1); defaultValue[0] = 0.0;
    std::vector<ScaFES::WriteHowOften> writeToFile(1, ScaFES::WriteHowOften::ALWAYS);
    std::vector<bool> computeError(1); computeError[0] = true;
    std::vector<double> geomparamsInit;

    PropagationFromLeftLowerCorner<double, DIM> ppp(paramsCl, gg, false,
                     nameDatafield, stencilWidth,
                     isKnownDf, nLayers, defaultValue, writeToFile,
                     computeError, geomparamsInit);
    ppp.iterateOverTime();
    return 0;
}
