#include <SCADOPT.hpp>
#include <TestLeapfrogUsedWhenDesired.hpp>

const int DIM = 1;

int main(int argc, char *argv[]) {
    ScaFES::Parameters paramsCl(argc, argv);
    ScaFES::GridGlobal<DIM> gg(paramsCl);

    std::vector<std::string> nameDatafield(1); nameDatafield[0] = "U";
    std::vector<int> stencilWidth(1); stencilWidth[0] = 0;
    std::vector<bool> isKnownDf(1); isKnownDf[0] = false;
    std::vector<int> nLayers(1); nLayers[0] = 0;
    std::vector<bool> optimizeForDf(1); optimizeForDf[0] = false;
    std::vector<double> defaultValue(1); defaultValue[0] = 0.0;
    std::vector<ScaFES::WriteHowOften> writeToFile(1, ScaFES::WriteHowOften::AT_START);
    std::vector<bool> computeError(1); computeError[0] = false;
    std::vector<double> geomparamsInit(1); geomparamsInit[0] = 0.0;

    if (2 > paramsCl.nTimesteps()) {
        throw std::runtime_error("Need at least 2 timesteps to perform test.");
    }

    TestLeapfrogUsedWhenDesired<double, DIM> ppp(paramsCl, gg, true,
                     nameDatafield, stencilWidth,
                     isKnownDf, nLayers, optimizeForDf,
                     defaultValue, writeToFile,
                     computeError, geomparamsInit);
    ppp.iterateOverTime();
    return 0;
}
