#include <SCADOPT.hpp>
#include <TestTimeProgresses.hpp>

const int DIM = 2;

int main(int argc, char *argv[]) {
    ScaFES::Parameters paramsCl(argc, argv);
    ScaFES::GridGlobal<DIM> gg(paramsCl);

    const int nDfs = 2;
    const int nParamsToOptimize = 3;
    
    char currName = 'A';
    std::vector<std::string> nameDatafield(nDfs);
    for (int ii = 0; ii < nDfs; ++ii) {
        nameDatafield[ii] = currName;
        ++currName;
    }
    std::vector<bool> isKnownDf(nDfs, false);
    std::vector<int> stencilWidth(nDfs, 0);
    stencilWidth[1] = 1;
    std::vector<int> nLayers(nDfs, 0);
    std::vector<bool> optimizeForDf(nDfs, false);
    std::vector<double> defaultValue(nDfs, 0.0);
    std::vector<ScaFES::WriteHowOften> writeToFile(nDfs,
                                                ScaFES::WriteHowOften::NEVER);
    std::vector<bool> computeError(nDfs, false);
    
    std::vector<double> geomparamsInit(nParamsToOptimize, 19);
    std::vector<double> geomparamsSol(nParamsToOptimize, 34);

    std::vector<bool> useLeapfrogScheme(2);
    useLeapfrogScheme[0] = false;
    useLeapfrogScheme[1] = true;
    
    for (std::size_t jj = 0; jj < useLeapfrogScheme.size(); ++jj) {
        TestTimeProgresses<double, DIM> ppp(paramsCl, gg,
                     useLeapfrogScheme[jj],
                     nameDatafield, stencilWidth,
                     isKnownDf, nLayers, optimizeForDf,
                     defaultValue, writeToFile,
                     computeError, geomparamsInit, geomparamsSol);
        ppp.iterateOverTime();
    }

    return 0;
}

