#!/bin/bash
#
# Script for configuring the underlying application.
#
# Copyright (c) 2011-2014, ZIH, TU Dresden, Federal Republic of Germany.
# For details, see the files COPYING and LICENSE in the base directory
# of the package.

export SCADOPT_VERSION="SCADOPT_REV$(svnversion)";
export SCADOPT_NAME_EXECUTABLE="$(basename $PWD)1D";
export SCADOPT_SPACE_DIM=1
export SCADOPT_N_NODES="8"
export SCADOPT_PARTITION_GRID="1"
export SCADOPT_COORD_NODE_FIRST="0"
export SCADOPT_COORD_NODE_LAST="1"
export SCADOPT_N_TIMESTEPS=2
export SCADOPT_N_SNAPSHOTS=1
export SCADOPT_START_TIME=0
export SCADOPT_END_TIME=1
export SCADOPT_OUTPUT_LEVEL=10
export SCADOPT_NLAYERS_AT_BORDER=1
export SCADOPT_NAME_KINDFILE=""
export SCADOPT_WRITE_KINDFILE="NO";
export SCADOPT_NAME_CONFIGFILE=""
export SCADOPT_ENABLE_ADOLC="YES"
export SCADOPT_ASYNCHRON_MODE="NO"
export SCADOPT_COMP_GRADIENTS="YES"
export SCADOPT_TF_TIME_DEPENDENT="NO"
export SCADOPT_RESULTS_DIR="./";
export SCADOPT_CHECK_RESULTS="NO";
#------------------------------------------------------------------------------#
export SCADOPT_RUN_MODE="NORMAL"
export SCADOPT_N_TESTS_MPI=2
export SCADOPT_N_TESTS_OPENMP=1
export SCADOPT_N_PROCESSES_MPI_START=1
export SCADOPT_N_THREADS_OPENMP_START=1
export SCADOPT_TYPE_SCALINGTEST="STRONG"
export SCADOPT_MACHINE_NAME="ZIH_ATLAS_N071";
export SCADOPT_MACHINE_N_NODES=1;
export SCADOPT_MACHINE_N_CORES_PER_NODE=64;

/usr/bin/time ./../../../scripts/executeScadoptApplication.sh
